unit princ;
{Collatinus - Extraction du lexique d'un texte latin.

Copyright (C) 1998-2001 Y. Ouvrard.

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le
modifier conformment aux dispositions de la Licence Publique Gnrale GNU,
telle que publie par la Free Software Foundation ; version 2 de la licence,
ou encore ( votre choix) toute version ultrieure.
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE
GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou D'ADAPTATION
A UN OBJET PARTICULIER.
Pour plus de dtail, voir la Licence Publique Gnrale GNU .
Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la
Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
Pour tout contact avec les auteurs : y.ouvrard@collatinus.com}

{  faire
    . rtablir l'affichage des tableaux ?
 }

interface

uses
  ShellApi, Windows, SysUtils, Classes, Controls, Forms, Dialogs,
  Menus, ExtCtrls, utiles, Buttons, StdCtrls,
  messages, IniFiles, ULex, ComCtrls, APropos;

type

  TFPrinc = class(TForm)
    MainMenu1: TMainMenu;
    Menu1: TMenuItem;
    Fin1: TMenuItem;
    Magister1: TMenuItem;
    N1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Lexique1: TMenuItem;
    motdepasse1: TMenuItem;
    vrifierforme1: TMenuItem;
    Texte1: TMenuItem;
    Analyse1: TMenuItem;
    motsuivant1: TMenuItem;
    phrasesuivante1: TMenuItem;
    Splitter1: TSplitter;
    lexiques1: TMenuItem;
    motsouslecurseur1: TMenuItem;
    dsinences1: TMenuItem;
    irrguliers1: TMenuItem;
    texteentier1: TMenuItem;
    Editio1: TMenuItem;
    effacerlesrsultats2: TMenuItem;
    diterletexte1: TMenuItem;
    N3: TMenuItem;
    texteverrouill1: TMenuItem;
    N4: TMenuItem;
    Enregistrer1: TMenuItem;
    toutcopier1: TMenuItem;
    copier1: TMenuItem;
    colller1: TMenuItem;
    supprimerlaligne1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Enregistrertout1: TMenuItem;
    Enregistrerletextesous1: TMenuItem;
    trierlevocabulaire2: TMenuItem;
    cesserlanalyse1: TMenuItem;
    Aide1: TMenuItem;
    sommaire1: TMenuItem;
    propos1: TMenuItem;
    N8: TMenuItem;
    options1: TMenuItem;
    Vocabulaireseul: TMenuItem;
    Formesplusvoc: TMenuItem;
    Analysesmorphocompltes1: TMenuItem;
    N6: TMenuItem;
    PanelOutils: TPanel;
    BNouveau: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton15: TSpeedButton;
    BEdite: TSpeedButton;
    BAnalyse: TSpeedButton;
    Nouveau1: TMenuItem;
    SpeedButton9: TSpeedButton;
    Affichage1: TMenuItem;
    N10: TMenuItem;
    Barredoutils1: TMenuItem;
    suitedutexte1: TMenuItem;
    SpeedButton10: TSpeedButton;
    StatusBar1: TStatusBar;
    textetxt1: TMenuItem;
    HTMLhtm1: TMenuItem;
    Memo1: TRichEdit;
    N5: TMenuItem;
    rechercherdansletextelatin1: TMenuItem;
    FindDialog1: TFindDialog;
    SpeedButton11: TSpeedButton;
    statistiques1: TMenuItem;
    MemoResultats: TRichEdit;
    ajouteruneentre1: TMenuItem;
    PanelJauge: TPanel;
    PanelProgression: TPanel;
    procedure Fin1Click(Sender: TObject);
    procedure Magister1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure motdepasse1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure texte1Click(Sender: TObject);
    procedure vrifierforme1Click(Sender: TObject);
    procedure motsuivant1Click(Sender: TObject);
    procedure motsouslecurseur1Click(Sender: TObject);
    procedure Memo1Click(Sender: TObject);
    procedure texteentier1Click(Sender: TObject);
    procedure formesplusvocClick(Sender: TObject);
    procedure phrasesuivante1Click(Sender: TObject);
    procedure Effacerlesrsultats1Click(Sender: TObject);
    procedure Vocabulaireseul1Click(Sender: TObject);
    procedure EntresetAnalyses1Click(Sender: TObject);
    procedure texteverrouill1Click(Sender: TObject);
    procedure Enregistrer1Click(Sender: TObject);
    procedure toutcopier1Click(Sender: TObject);
    procedure colller1Click(Sender: TObject);
    procedure Enregistrertout1Click(Sender: TObject);
    procedure SaveDialog1TypeChange(Sender: TObject);
    procedure trierlevocabulaire1Click(Sender: TObject);
    procedure cesserlanalyse1Click(Sender: TObject);
    procedure supprimerlaligne1Click(Sender: TObject);
    procedure Nouveau1Click(Sender: TObject);
    procedure copier1Click(Sender: TObject);
    procedure sommaire1Click(Sender: TObject);
    procedure Barredoutils1Click(Sender: TObject);
    procedure suitedutexte1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure propos1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure textetxt1Click(Sender: TObject);
    procedure HTMLhtm1Click(Sender: TObject);
    procedure Memo1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Memo1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure rechercherdansletextelatin1Click(Sender: TObject);
    procedure FindDialog1Show(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure Enregistrerletextesous1Click(Sender: TObject);
    procedure statistiques1Click(Sender: TObject);
    procedure dsinences1Click(Sender: TObject);
    procedure lexiques1Click(Sender: TObject);
    procedure irrguliers1Click(Sender: TObject);
    procedure ajouteruneentre1Click(Sender: TObject);
    procedure aide(page : string);
  private
    { Dclarations prives }
    IniBis : string;
    code : string;
    NomDuFichier : string;
    XCurseur, YCurseur : integer;
    TexteA : string;
    iProgression, LongueurA : integer;
    procedure AffecteNom(const Nom : String);
    Procedure Precaution ;
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
    function AnalyseT : TStringList;
    procedure Jauge;
   public
    { Dclarations publiques }
    ModeA : integer;
    Mot : String;
    FinDanalyse : integer;
    Procedure Ouvre(FileName : String);
    Procedure MotSuivant;
    Function MotSousCurseur(Cpos : integer) : String;
    procedure AfficheHint(var HintStr: string; var CanShow: Boolean;
      var HintInfo: THintInfo);
  end;

  TCollatIniFile = Class(TCustomInifile)
    private
    // procedure WriteBool(const Section, Ident: string; Value: Boolean);
    // procedure WriteInteger(const Section, Ident: string; Value: Integer);
    public
    FFileName : string;
    constructor Create( FileName : string );
    destructor Destroy; override;
    function ReadString(const Section, Ident, Default: string): string; override;
    procedure WriteString(const Section, Ident, Value: String); override;
    procedure ReadSection(const Section: string; Strings: TStrings); override;
    procedure ReadSections(Strings: TStrings); override;
    procedure ReadSectionValues(const Section: string; Strings: TStrings); override;
    procedure EraseSection(const Section: string); override;
    procedure DeleteKey(const Section, Ident: String); override;
    procedure UpdateFile; override;
  end;

var
  FPrinc: TFPrinc;
  ouvert : boolean;
implementation

{$R *.DFM}

uses MotDePasse, UDes, UIrreg, UListes, UMorpho, UHTML, MulotEdt,
  DLex, DDico, DDes, DIrreg; // , UTest;

{ TFPrinc }  

procedure TFPrinc.Fin1Click(Sender: TObject);
begin
   Close;
end;

procedure TFPrinc.Magister1Click(Sender: TObject);
begin
if not Lexique1.Visible then
  With DMdePasse do
    begin
    if (ShowModal = mrOK) and
       (password.text = code) then
       lexique1.Visible := true;
    end
  else Lexique1.Visible := False;
  Magister1.Checked := Lexique1.Visible;
end;

procedure TFPrinc.FormClose(Sender: TObject; var Action: TCloseAction);
var IniFile : TCollatIniFile;
    Nom_fichier : String;
begin
if IniBis > ''
   then Nom_Fichier := IniBis + '\collatinus.ini'
   else Nom_Fichier := ChangeFileExt(Paramstr(0), '.ini');
// IniFile := TIniFile.Create( 'd:\delphi\collatinus5\exe\collatinus.ini'{Nom_Fichier} );
IniFile := TCollatIniFile.Create( Nom_Fichier );
With IniFile do
    begin
      WriteString ( 'Dernire session', 'Rpertoire',
        ExtractFilePath ( NomDuFichier ) );
      WriteString('Dernire session', 'Fichier', NomDuFichier);
      WriteString('Code', 'mot', DMdePasse.cripte(code));
      WriteBool('Dernire session', 'Magister', Lexique1.Visible);
      WriteBool('Dernire session', 'Barre d''outils', Barredoutils1.Checked);
      // mode d'analyse
      if formesplusvoc.Checked
        then ModeA := 0
      else if Vocabulaireseul.Checked
        then ModeA := 1
      else if Analysesmorphocompltes1.Checked
        then ModeA := 2
      else ModeA := 3;
      WriteInteger('Dernire session', 'Mode analyse', ModeA);

      WriteBool('Coordonnees', 'Maxi', Fprinc.WindowState = wsMaximized);
      WriteInteger('Coordonnees', 'Haut', FPrinc.Top);
      WriteInteger('Coordonnees', 'Gauche',FPrinc.Left);
      WriteInteger('Coordonnees', 'Large', FPrinc.Width );
      WriteInteger('Coordonnees', 'Hauteur', FPrinc.Height );
      IniFile.Free;
    end;
Application.HelpCommand(HELP_Quit, 0);
end;

procedure TFPrinc.motdepasse1Click(Sender: TObject);
var C : String;
begin
with DMDePasse do
  begin
  ShowModal;
  if ModalResult <> mrOK then exit;
  C := Password.text;
  ShowModal;
  if ModalResult <> mrOK then exit;
  if Password.text = C then
    begin
    Code := C;
    ShowMessage('Changement enregistr');
    end
    else
    ShowMessage('Les deux saisies ne concordent pas. '+
                'Il faut recommencer');
    end;
end;

procedure TFPrinc.FormCreate(Sender: TObject);
var IniFile : TCollatIniFile;
    max : boolean;
begin
// lecture de l'ini voisin de l'excutable
IniFile := TCollatIniFile.Create(ChangeFileExt(Paramstr(0),'.ini'));
// vrifier la prsence d'une redirection
IniBis := IniFile.ReadString('ini', 'bis', '');
if IniBis > '' then
   begin
      IniFile.Free;
      IniFile := TCollatIniFile.Create(IniBis + '\collatinus.ini');
   end;
// lecture des paramtres
With IniFile do
  begin
  if Paramstr(1) = '' then
    Begin
    OpenDialog1.InitialDir := ReadString(
        'Dernire session', 'Rpertoire', extractFilePath(Paramstr(0)));
    OpenDialog1.FileName :=
      ExtractFileName(ReadString(
        'Dernire session', 'Fichier', 'acaesar.txt'))
    end
      else
    Begin
    OpenDialog1.InitialDir := ExtractFilePath(ParamStr(1));
    OpenDialog1.FileName := ExtractFileName(ParamStr(1));
    end;
  Code := DMdePasse.Decripte(ReadString('Code', 'mot', DMdePasse.cripte('magister')));
  Lexique1.visible :=
    ReadBool( 'Dernire session', 'Magister', false);
  Magister1.Checked := Lexique1.Visible;
  ModeA := ReadInteger('Dernire session', 'Mode analyse', 1);
  Case ModeA of
    0 : formesplusvoc.Checked := true;
    1 : Vocabulaireseul.Checked := true;
    2 : Analysesmorphocompltes1.Checked := true;
    end;
  Barredoutils1.Checked := ReadBool('Dernire session', 'Barre d''outils', true);
  PanelOutils.Visible := Barredoutils1.Checked;
  max := ReadBool('Coordonnees', 'Maxi', false);
  if max then
    begin
       FPrinc.WindowState := wsMaximized;
    end
    else
      Begin
      FPrinc.Top := ReadInteger('Coordonnees', 'Haut', 100);
      FPrinc.Left := ReadInteger('Coordonnees', 'Gauche',200);
      FPrinc.Width := ReadInteger('Coordonnees', 'Large', 600);
      FPrinc.Height := ReadInteger('Coordonnees', 'Hauteur',  500); 
      FPrinc.WindowState := wsNormal;
      end;
  end;
iniFile.Free;

// Apparence
Memo1.color := $00FFFFF0 ;
MemoResultats.Clear;
MemoResultats.Align := AlClient;
PanelProgression.width := 0;

Application.OnShowHint := AfficheHint;
// Application.OnHint := AfficheAide;
ouvert := false;
end;


procedure TFPrinc.FormActivate(Sender: TObject);
begin
if ouvert then exit;
  Ouvert := true;
  With Opendialog1 do Ouvre(Initialdir+'\'+FileName);
end;

Procedure TFPrinc.MotSuivant; // affecter le mot suivant;
Begin
With Memo1 do
  begin
  SelStart := SelStart + SelLength;
  SelStart := MotADroite(Memo1);
  if SelStart >= length(Text) then exit;
 { While not (Text[SelStart + 1] in lettres) do
      Begin
      // SelStart := Succ(SelStart);
      // vrif fin de phrase et fin de texte
      if SelStart >= length(Text) then exit;
      end;}
  SelLength := 0;
  While Text[SelStart+SelLength+1]in lettres do selLength := SelLength + 1;
  Mot := Memo1.SelText;
  if Mot = '' then MotSuivant;
  end;
end;

Procedure TFPrinc.Ouvre(FileName : String);
Begin
Try
  Memo1.Lines.LoadFromFile(FileName);
  AffecteNom(FileName);
  SaveDialog1.InitialDir := ExtractFilePath(FileName);
  SaveDialog1.FileName := ExtractFileName(FileName);
  OpenDialog1.InitialDir := SaveDialog1.InitialDir;
  except
  Caption := sansnom + '.txt';
  SaveDialog1.FileName := Caption;
  end;
Memo1.Modified := False;
NomDuFichier := FileName;
end;

procedure TFPrinc.texte1Click(Sender: TObject);
begin
Try
 Precaution;
 with OpenDialog1 do if Execute then
  Ouvre(FileName);
 except
 end;
end;

procedure TFPrinc.vrifierforme1Click(Sender: TObject);
 var
    liste : TstringList;
    inventum : Boolean;
begin
mot := inputBox('vrification', 'forme :', '');
Liste := AnalysesDe(mot, inventum, ModeA);
MemoResultats.Lines.AddStrings(Liste);
Liste.Free;
end;

procedure TFPrinc.motsuivant1Click(Sender: TObject);
begin
motSuivant;
Memo1.ReadOnly := True;
Memo1Click(Sender);
end;

Function TFPrinc.MotSousCurseur(Cpos : integer) : String;
begin
result := '';
CPos := Memo1.SelStart;
// vrifier qu'un texte est prsent
if Memo1.text = '' then exit;
while Memo1.text[CPos] in lettres do dec(CPos);
while not (Memo1.text[Cpos] in lettres) do inc(CPos);
While Memo1.Text[Cpos] in lettres do
  begin
    result := result + Memo1.Text[CPos];
    inc(Cpos);
  end;
result := VJversUI(result);
end;

procedure TFPrinc.motsouslecurseur1Click(Sender: TObject);
begin
// Mot := MotSousCurseur(Memo1.SelStart); // t le 31 mai 1998
Memo1Click(Sender);
end;

procedure TFPrinc.Memo1Click(Sender: TObject);
// Attention ! mthode appele par toutes les options d'analyse.
var
  MotSC : string;
  Liste : TStringList;
  inventum : Boolean;
begin
With Memo1 do
  begin
    if not readOnly or (text = '') then exit;
    Application.ProcessMessages;
    MotSC := MotSousCurseur(SelStart);
  end;
  if MotSC = '' then exit;

  Liste := AnalysesDe(MotSC, inventum, ModeA);

  // MemoResultats.Lines.AddStrings(Liste);
  MemoResultats.Text := MemoResultats.Text + Liste.text;
  Liste.Free;

  // montrer les nouveaux rsultats en dfilant MemoResultats
  MemoResultats.SelStart := MemoResultats.GetTextLen;
  MemoResultats.SelLength := 0;
end;


procedure TFPrinc.texteentier1Click(Sender: TObject);
begin
if not Memo1.ReadOnly then texteverrouill1Click(Sender);
TexteA := Memo1.Text;
MemoResultats.Clear;
MemoResultats.Lines := AnalyseT;
end;

procedure TFPrinc.formesplusvocClick(Sender: TObject);
begin
if Not formesplusvoc.Checked then
  Begin
  formesplusvoc.Checked := True;
  ModeA := maFormesVoc;
  end;
end;

procedure TFPrinc.phrasesuivante1Click(Sender: TObject);
begin
Memo1.ReadOnly := true;
FinDAnalyse := succ(memo1.SelStart);
While not (Memo1.Text[FinDAnalyse] in ['.', '?', '!']) and
      (FinDAnalyse < Memo1.GetTextLen) do inc(FinDAnalyse);
With Memo1
  do MemoResultats.Lines.AddStrings(AnalyseTexte (
     copy(Text, SelStart, FinDAnalyse - SelStart + 1)));
Memo1.SelStart := FinDAnalyse + 2;
end;

procedure TFPrinc.Effacerlesrsultats1Click(Sender: TObject);
begin
MemoResultats.Clear;
end;

procedure TFPrinc.Vocabulaireseul1Click(Sender: TObject);
begin
if Not Vocabulaireseul.Checked then
  Begin
  Vocabulaireseul.Checked := True;
  ModeA := maVocSeul;
  end;
end;

procedure TFPrinc.EntresetAnalyses1Click(Sender: TObject);
begin
if Not Analysesmorphocompltes1.Checked then
  Begin
  Analysesmorphocompltes1.Checked := True;
  ModeA := maAnalyses ;
  end;
end;

procedure TFPrinc.texteverrouill1Click(Sender: TObject);
begin
if texteverrouill1.Checked then
  diterletexte1.Checked := true
  else
  texteverrouill1.Checked := true;
Memo1.ReadOnly := texteverrouill1.Checked;
BAnalyse.Down := Memo1.ReadOnly;
BEdite.Down := Not Memo1.readOnly;
end;

procedure TFPrinc.Enregistrer1Click(Sender: TObject);
begin
// si enregistrer sous, ou texte sans nom, bote.
// si enregistrer tout court, pas de bote.
if (pos(sansnom, SaveDialog1.FileName) > 0)
  then Enregistrerletextesous1Click(Sender)
    else
    if (Sender = Enregistrerletextesous1) or
        Memo1.Modified then
          Memo1.Lines.SaveToFile(
            ChangeFileExt(SaveDialog1.FileName, '.txt'));
Memo1.Modified := False;
end;

procedure TFPrinc.toutcopier1Click(Sender: TObject);
begin
With Memo1 do if Focused then
  begin
  SelectAll;
  CopyToClipBoard;
  end else
  With Memoresultats do
  Begin
  SelectAll;
  CopyToClipBoard;
  end;
end;

procedure TFPrinc.colller1Click(Sender: TObject);
begin
With Memo1 do if Focused then PasteFromClipBoard
  else
  Memoresultats.PasteFromClipBoard;
end;

procedure TFPrinc.Enregistrertout1Click(Sender: TObject);
var Lignes : TStringList;
    i, fait, tiers : integer;
  Function EntreeGras(Li : string) : String;
  var ilettre : integer;
  Begin
  Result := '<B>';
  ilettre := 1;
  While not (Li[ilettre] in lettres) do
    Begin
      Result := Result + Li[ilettre];
      inc(ilettre);
    end;
  While Li[ilettre] in lettres do
    Begin
      Result := Result + Li[ilettre];
      inc(ilettre);
    end;
  result := result + '</B>' +
    copy ( Li, ilettre, length(Li));
  end;
begin
  With SaveDialog1 do if Sender = textetxt1
    then
      Begin
        FilterIndex := 1;
        FileName := ChangeFileExt(FileName, '.txt');
      end
    else
      Begin
        SaveDialog1.FilterIndex := 2;
        FileName := ChangeFileExt(FileName, '.htm');
      end;

Lignes := TStringList.Create;
With SaveDialog1 do if execute then
  Case FilterIndex of
    1 :
      Begin
      // Texte
      Lignes.AddStrings(Memo1.Lines);
      Lignes.Add('__________');
      Lignes.AddStrings(MemoResultats.Lines);
      Lignes.SaveToFile(FileName);
      end;
    2 :
       Begin
       // Aller chercher les paramtres du fichier HTML :
       DHTML.ShowModal;
       // Dbut de structure
       Lignes.Add('<HTML>');
       // Titre ;
       Lignes.Add('<HEAD><TITLE>' +
           DHTML.EditTitre.Text +
           '</TITLE>');
       // Mots cls ;
       Lignes.Add('<Meta name="keywords" content="' +
          DHTML.EditMotsCles.text + '">');
       Lignes.Add('</HEAD>');
       // paramtres
       Lignes.Add('<BODY bgcolor="#' +
       rrggbb(DHTML.ColorDialog1.Color) + '">');
       // Titre
       Lignes.Add('<H3><DIV align="center">' +
         DHTML.EditTitre.Text +
         '</DIV></H3>');
       // intro minimum en italiques
       Lignes.Add('<I> Ici l''intro</I><P>');
       // texte
       // balise d'alignement
       Lignes.Add('<DIV Align="justify">');
       if DHTML.CheckBoxRetours.Checked then
          For i := 0 to Memo1.lines.count-1 do
          Lignes.Add(Memo1.Lines[i]+'<BR>')
          else
          For i := 0 to Memo1.lines.count-1 do
          Lignes.Add(Memo1.Lines[i]);
       // fermeture alignement
       Lignes.Add('</DIV>');
       // Vocabulaire
       Lignes.Add('<CENTER><TABLE width="100%">');
       Lignes.Add('<TR valign="top">');

       Lignes.Add('<TD width = "33%">');
       Lignes.Add('<FONT size="-2">');
       Tiers := MemoResultats.Lines.count div 3 ;
       For i := 0 to tiers do Lignes.Add(
         EntreeGras(MemoResultats.lines[i]+'<BR>'));
       Lignes.Add('</FONT>');
       Lignes.Add('</TD><TD width="33%">');

       fait := tiers;

       Lignes.Add('<FONT size="-2">');
       For i := fait+1 to tiers*2 do
         Lignes.Add(EntreeGras(MemoResultats.lines[i]+'<BR>'));
         // Lignes.Add(MemoResultats.lines[i]+'<BR>');
       Lignes.Add('</FONT>');
       Lignes.Add('</TD><TD width="33%">');

       fait := tiers*2;

       Lignes.Add('<FONT size="-2">');
       For i := fait+1 to MemoResultats.lines.count-1 do
         Lignes.Add(EntreeGras(MemoResultats.lines[i]+'<BR>'));
         // Lignes.Add(MemoResultats.lines[i]+'<BR>');
       Lignes.Add('</FONT>');
       Lignes.Add('</TD>');

       Lignes.Add('</TR>');
       Lignes.Add('</TABLE></CENTER>');

       // Fin de structure
       Lignes.Add('</BODY>');
       Lignes.Add('</HTML>');

       Lignes.SaveToFile(changeFileExt(FileName, '.htm'));
       Memo1.Modified := false;
       MemoResultats.Modified := false;
       end;// html;
    end;
  Lignes.Free;
end;

procedure TFPrinc.SaveDialog1TypeChange(Sender: TObject);
// change l'extension du nom de fichier selon le filtre
begin
with SaveDialog1 do
  Case FilterIndex of
    1 :
      begin
        FileName := ChangeFileExt(FileName, '.txt');
        DefaultExt := 'txt';
      end;
    2 :
      begin
        FileName := ChangeFileExt(FileName, '.htm');
        DefaultExt := 'htm';
      end;
    end;
end;

procedure TFPrinc.trierlevocabulaire1Click(Sender: TObject);
var Liste : TStringList;
begin
// Le vocabulaire, par ordre alphabtique;
Liste := TStringList.Create;
Liste.Duplicates := dupIgnore ;
Liste.Sorted := True;
Liste.assign(MemoResultats.Lines);
MemoResultats.Clear;
MemoResultats.Lines.assign(Liste);
Liste.Free;
end;

procedure TFPrinc.cesserlanalyse1Click(Sender: TObject);
begin
// mettre findanalyse  0, ce qui arrtera la boucle aprs
// Application.ProcessMessages.
FinDAnalyse := 0;
end;

procedure TFPrinc.supprimerlaligne1Click(Sender: TObject);
var L : integer;
begin
//sortir si memoResultats n'est pas slectionn
if not MemoResultats.Focused then exit;
// supprimer la ligne courante
L := SendMessage(MemoResultats.Handle, EM_LINEFROMCHAR, -1, 0);   //$FFFF
if L > -1 then MemoResultats.Lines.Delete(L);
end;

procedure TFPrinc.Nouveau1Click(Sender: TObject);
begin
// nouveau fichier
// prvoir un dialogue de prcaution.
Try
  Precaution
  except
  exit
  end;
Memo1.Clear;
AffecteNom(sansnom + '.txt');
SaveDialog1.FileName := NomDuFichier;
if texteverrouill1.Checked then texteverrouill1Click(nil);
end;

procedure TFPrinc.copier1Click(Sender: TObject);
begin
// copier
With Memo1 do if Focused then CopyToClipBoard
  else
  Memoresultats.CopyToClipBoard;
end;

procedure TFPrinc.sommaire1Click(Sender: TObject);
begin
// aide : sommaire
   aide('index');
end;

procedure TFPrinc.Barredoutils1Click(Sender: TObject);
begin
With Barredoutils1 do
  Begin
  Checked := not Checked;
  PanelOutils.Visible := Checked;
  end;
end;

procedure TFPrinc.suitedutexte1Click(Sender: TObject);
begin
// analyse la fin du texte  partir du curseur
PanelJauge.Show;
Memo1.ReadOnly := true;
FinDAnalyse := Memo1.GetTextLen - 1;
with Memo1
   do TexteA := copy(text, SelStart, GetTextLen);
MemoResultats.Lines.AddStrings(AnalyseT);
PanelJauge.Hide;
end;

// Fichiers

procedure TFPrinc.AffecteNom(const Nom : String);
begin
  NomDuFichier := Nom;
  Caption := Format('%s - %s', [ExtractFileName(Nom), Application.Title]);
end;

procedure TFPrinc.Precaution;
var
  Reponse : Integer;
begin
  if not (Memo1.Modified or MemoResultats.Modified) then Exit;
  Reponse := MessageDlg(Format('%s modifi. Enregistrer ?', [NomDuFichier]),
    mtConfirmation, mbYesNoCancel, 0);
  case Reponse of
    idYes: Enregistrer1Click(Self);
    idNo: {Nothing};
    idCancel: Abort;
  end;
end;

procedure TFPrinc.FormShow(Sender: TObject);
begin
DragAcceptFiles(Handle, True);
end;

procedure TFPrinc.WMDropFiles(var Msg: TWMDropFiles);
var
  CFileName: array[0..MAX_PATH] of Char;
begin
  try
    if DragQueryFile(Msg.Drop, 0, CFileName, MAX_PATH) > 0 then
    begin
      precaution;
      Ouvre(CFileName);
      Msg.Result := 0;
    end;
  finally
    DragFinish(Msg.Drop);
  end;
end;

procedure TFPrinc.propos1Click(Sender: TObject);
begin
With TDApropos.Create(self) do
  Try
    ShowModal;
  Finally
    Free;
  end;
end;

procedure TFPrinc.AfficheHint(var HintStr: string; var CanShow: Boolean;
      var HintInfo: THintInfo);
begin
  With HintInfo do
      begin
        ReshowTimeout := 100;
      end;
end;

procedure TFPrinc.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
Try
  Precaution;
  except
  CanClose := False;
  end;
end;

procedure TFPrinc.textetxt1Click(Sender: TObject);
begin
  // enregistrer texte
  Enregistrertout1Click(textetxt1);
end;

procedure TFPrinc.HTMLhtm1Click(Sender: TObject);
begin
  // enregistrer html
  Enregistrertout1Click(HTMLhtm1);
end;

procedure TFPrinc.Memo1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
  var
    A : TStringList;
    inventum : Boolean;
begin
  inventum := false;
  Memo1.ShowHint := True;
  A := nil;
  Try
    A := AnalysesDe(
      REExtractWordFromPos(Memo1, X, Y), inventum, maAnalyses);
    if inventum
      then Memo1.Hint := A.Text
      else Memo1.ShowHint := False ;
    Finally
    A.Free;
    end;
end;

procedure TFPrinc.Memo1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  MotSC : string;
  Liste : TStringList;
  inventum : Boolean;
begin
if Button = mbLeft then
  begin
    With Memo1 do
      begin
      if not readOnly or (text = '') then exit;
      Application.ProcessMessages;
      MotSC := MotSousCurseur(SelStart);
      end;
    if MotSC = '' then exit;

    Liste := AnalysesDe(MotSC, inventum, ModeA);

    MemoResultats.Lines.AddStrings(Liste);
    Liste.Free;

    // montrer les nouveaux rsultats en dfilant MemoResultats
    MemoResultats.SelStart := MemoResultats.GetTextLen;
    MemoResultats.SelLength := 0;
  end
  else
  if Button = mbRight then
  begin
    XCurseur := X;
    YCurseur := Y;
  end;
end;

procedure TFPrinc.rechercherdansletextelatin1Click(Sender: TObject);
begin
  // rechercher du texte
 FindDialog1.execute;
end;

procedure TFPrinc.FindDialog1Show(Sender: TObject);
begin
  Memo1.SelStart := 0;
end;

procedure TFPrinc.FindDialog1Find(Sender: TObject);
var
  SelPos: Integer;
begin
  with TFindDialog(Sender) do
  begin
    { Effectuer une recherche globale dans Memo1 }
      SelPos := Memo1.FindText(FindText, Memo1.SelStart + 1,
        Length(Memo1.Text), []);
    if SelPos > 0 then
    begin
      Memo1.SelStart := SelPos;
      Memo1.SelLength := Length(FindText);
    end
    else MessageDlg(
      Concat('Impossible de trouver "', FindText, '".'),
      mtError, [mbOk], 0);
  end;
end;

procedure TFPrinc.Enregistrerletextesous1Click(Sender: TObject);
begin
 With SaveDialog1 do if not Execute then exit;
    SaveDialog1.FileName :=
      ChangeFileExt(SaveDialog1.fileName, '.txt');
    AffecteNom(SaveDialog1.FileName);
    OpenDialog1.InitialDir := SaveDialog1.InitialDir;
    OpenDialog1.FileName := ExtractFileName(SaveDialog1.fileName);
    Memo1.Lines.SaveToFile(SaveDialog1.FileName);
end;

procedure TFPrinc.statistiques1Click(Sender: TObject);
  var M : TStringList;
begin
  M := Lexique.Stats ;
  ShowMessage(M.Text);
  M.Free;
end;

procedure TFPrinc.dsinences1Click(Sender: TObject);
begin
  // diter les dsinences
  FDes.modifie := False;
  FDes.ShowModal;
  Lexique.Modifie := Lexique.Modifie or FDes.modifie;
end;

procedure TFPrinc.lexiques1Click(Sender: TObject);
begin
   // diter le lexique
   FDico.ShowModal;
   // l'enregistrer ?
end;

procedure TFPrinc.irrguliers1Click(Sender: TObject);
begin
   // diter les irrguliers
   FIrreg.modifie := false;
   FIrreg.ShowModal;
   Lexique.Modifie := Lexique.Modifie or FIrreg.modifie;
end;

procedure TFPrinc.ajouteruneentre1Click(Sender: TObject);
var
   D : TDonneesLexicales;
begin
D := TDonneesLexicales.Create(-1, -1, '', '', '');
Flex.Affiche('', D);
D.Free;
if (Flex.ShowModal = mrOK) and (Flex.EditCanon.Text > '')
  then Lexique.AjouteAuLexique( false, Flex.Entree, Flex.Donnees);
end;

function TFPrinc.AnalyseT : TStringList;
var
   i : integer;
   mot : string;
   AnalyseMot : TStringList;
   inventum : boolean;
begin
PanelJauge.Show;
PanelProgression.Width := 0;
result := TStringList.Create;
iProgression := 1;
LongueurA := length(TexteA);
for i := 1 to LongueurA do
   if TexteA[i] in lettres
      then mot := mot + TexteA[i]
      else
         begin
            if mot > '' then
               begin
                  analyseMot := AnalysesDe (mot, inventum, ModeA);
                  Result.AddStrings(analyseMot);
                  analyseMot.free;
                  iProgression := i;
                  Jauge;
               end;
            mot := '';
         end;
PanelJauge.Hide;
MemoResultats.Lines.Add('Affichage...');
Application.ProcessMessages;
end;

procedure TFPrinc.Jauge;
var
   p : real;
   l : real;
begin
   p := iProgression;
   l  := Memo1.GetTextLen;
   panelProgression.Width :=
      round(PanelJauge.Width * (p/l));
end;

procedure TFPrinc.aide(page: string);
begin
ShellExecute(
   0, Nil,
   PChar(extractFilePath(Paramstr(0)) + 'aide\' + page + '.html'),
   '', nil, SW_NORMAL);
end;

{ TCollatIniFile }

constructor TCollatIniFile.Create(FileName: string);
begin
  FFileName := FileName;
end;

procedure TCollatIniFile.DeleteKey(const Section, Ident: String);
begin
  WritePrivateProfileString(PChar(Section), PChar(Ident), nil,
     PChar(FFileName));
end;

destructor TCollatIniFile.Destroy;
begin
  UpdateFile;         // flush changes to disk
  inherited Destroy;
end;

procedure TCollatIniFile.EraseSection(const Section: string);
begin
  if not WritePrivateProfileString(PChar(Section), nil, nil,
    PChar(FFileName)) then
    // raise EIniFileException.CreateResFmt(@SIniFileWriteError, [FileName]);
    exit;
end;

procedure TCollatIniFile.ReadSection(const Section: string;
  Strings: TStrings);
const
  BufSize = 16384;
var
  Buffer, P: PChar;
begin
  GetMem(Buffer, BufSize);
  try
    Strings.BeginUpdate;
    try
      Strings.Clear;
      if GetPrivateProfileString(PChar(Section), nil, nil, Buffer, BufSize,
        PChar(FFileName)) <> 0 then
      begin
        P := Buffer;
        while P^ <> #0 do
        begin
          Strings.Add(P);
          Inc(P, StrLen(P) + 1);
        end;
      end;
    finally
      Strings.EndUpdate;
    end;
  finally
    FreeMem(Buffer, BufSize);
  end;
end;

procedure TCollatIniFile.ReadSections(Strings: TStrings);
const
  BufSize = 16384;
var
  Buffer, P: PChar;
begin
  GetMem(Buffer, BufSize);
  try
    Strings.BeginUpdate;
    try
      Strings.Clear;
      if GetPrivateProfileString(nil, nil, nil, Buffer, BufSize,
        PChar(FFileName)) <> 0 then
      begin
        P := Buffer;
        while P^ <> #0 do
        begin
          Strings.Add(P);
          Inc(P, StrLen(P) + 1);
        end;
      end;
    finally
      Strings.EndUpdate;
    end;
  finally
    FreeMem(Buffer, BufSize);
  end;
end;

procedure TCollatIniFile.ReadSectionValues(const Section: string;
  Strings: TStrings);
var
  KeyList: TStringList;
  I: Integer;
begin
  KeyList := TStringList.Create;
  try
    ReadSection(Section, KeyList);
    Strings.BeginUpdate;
    try
      Strings.Clear;
      for I := 0 to KeyList.Count - 1 do
        Strings.Add(KeyList[I] + '=' + ReadString(Section, KeyList[I], ''))
    finally
      Strings.EndUpdate;
    end;
  finally
    KeyList.Free;
  end;
end;

function TCollatIniFile.ReadString(const Section, Ident, Default: string): string;
var
  Buffer: array[0..2047] of Char;
begin
  SetString(Result, Buffer, GetPrivateProfileString(PChar(Section),
    PChar(Ident), PChar(Default), Buffer, SizeOf(Buffer), PChar(FFileName)));
end;

procedure TCollatIniFile.UpdateFile;
begin
  WritePrivateProfileString(nil, nil, nil, PChar(FFileName));
end;

procedure TCollatIniFile.WriteString(const Section, Ident, Value: string);
begin
  if not  WritePrivateProfileString(PChar(Section), PChar(Ident),
    PChar(Value), PChar(FFileName))
  then showMessage('erreur');
end;


end.
