unit DIrreg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, UDes;

type
  TFIrreg = class(TForm)
    LabelK: TLabel;
    BitBtn1: TBitBtn;
    ListBoxF: TListBox;
    EditC: TEdit;
    BtnSuppr: TBitBtn;
    BtnModif: TBitBtn;
    BtnAjout: TBitBtn;
    procedure EditCChange(Sender: TObject);
    procedure EditCKeyPress(Sender: TObject; var Key: Char);
    procedure BtnSupprClick(Sender: TObject);
    procedure BtnModifClick(Sender: TObject);
    procedure BtnAjoutClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    modifie : boolean;
    arriere : boolean;
    p : integer;
    Def : TDef;
  end;

var
  FIrreg: TFIrreg;

implementation

{$R *.dfm}

uses Ulistes, utiles, ULex, UIrreg, DSaisieIrr;

procedure TFIrreg.EditCChange(Sender: TObject);
var
   textus : string;
   l : integer;
   affiche : boolean;
begin
  textus := lowerCase(EditC.text);
  affiche := true;
  if not Lexique.Find(EditC.text, p) then
     with Lexique
         do if not arriere then
            begin
              if p >= Lexique.count
                then p := Lexique.count - 1;
              if pos(EditC.Text, Lexique[p]) = 1 then
                begin
                  l := length(Textus);
                  EditC.Text := Textus
                    + copy(strings[p], l + 1, length(strings[p]));
                  EditC.selStart := l;
                  EditC.selLength := 99;
                end
                else affiche := false;
            end
            else affiche := false;
   if affiche
      then Irregs.IrregsK(EditC.Text, ListBoxF.Items);
end;

procedure TFIrreg.EditCKeyPress(Sender: TObject; var Key: Char);
begin
  arriere := Key = #8;
end;

procedure TFIrreg.BtnSupprClick(Sender: TObject);
begin
   // supprime la forme irrgulire slectionne dans listBoxF
   if ListBoxF.ItemIndex > -1
      then Irregs.DeleteKF(EditC.Text, ListBoxF.ItemIndex);
   EditCChange(nil);
   modifie := true;
end;

procedure TFIrreg.BtnModifClick(Sender: TObject);
var N : integer;
begin
N := ListBoxF.ItemIndex;
if N > -1 then
   begin
      FSaisieIrr.LabelK.Caption := EditC.Text;
      FSaisieIrr.Def := Irregs.DefKNum(EditC.Text, N);
      FSaisieIrr.LabelM.Caption := FSaisieIrr.Def.Graphie(false);
      FSaisieIrr.EditF.Text := Irregs.GraphieFNum(EditC.Text, N);
      if FSaisieIrr.ShowModal = mrOK then
         begin
            Irregs.DeleteKF(EditC.Text, N);
            Irregs.Ajoute(FsaisieIrr.EditF.Text, EditC.Text,
               FSaisieIrr.Def.Flags, Lexique.Donnees(p, true).modele);
            Lexique.Modifie := true;
         end;
   end;
end;

procedure TFIrreg.BtnAjoutClick(Sender: TObject);
begin
   // ajouter un irrgulier
FSaisieIrr.LabelK.Caption := EditC.Text;
FSaisieIrr.EditF.Clear;
FSaisieIrr.BtnElClick(nil);
if FSaisieIrr.ShowModal = mrOK then
   begin
      {C : forme irrgulire; K : Canon; F : Flags; M : modle (!)}
      Irregs.Ajoute(FsaisieIrr.EditF.Text, EditC.Text,
         FSaisieIrr.Def.Flags, Lexique.Donnees(p, true).modele);
      Lexique.Modifie := true;
   end;
end;

end.
