unit MotDePasse;
{Collatinus - Extraction du lexique d'un texte latin.

Copyright (C) 1998 Y. Ouvrard.

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le
modifier conformment aux dispositions de la Licence Publique Gnrale GNU,
telle que publie par la Free Software Foundation ; version 2 de la licence,
ou encore ( votre choix) toute version ultrieure.
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE
GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou D'ADAPTATION
A UN OBJET PARTICULIER.
Pour plus de dtail, voir la Licence Publique Gnrale GNU .
Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la
Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
Pour tout contact avec les auteurs : zarlino@iname.com}

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons;

type
  TDMdePasse = class(TForm)
    Label1: TLabel;
    Password: TEdit;
    OKBtn: TButton;
    CancelBtn: TButton;
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function cripte(C : string) : string;
    function decripte(C : string) : string;
  end;

var
  DMdePasse: TDMdePasse;

implementation

{$R *.DFM}


function TDMdePasse.cripte(C : string) : string;
  var i : integer;
  begin
  Result := C;
  for i := 1 to length(C) do
    Result[i] := pred(Result[i]);
  end;

function TDMdePasse.decripte(C : string) : string;
  var i : integer;
  begin
  Result := C;
  for i := 1 to length(C) do
    Result[i] := succ(Result[i]);
  end;

procedure TDMdePasse.FormActivate(Sender: TObject);
begin
password.clear;
end;

end.

